package monitor;

/**
 *  Classe Monitor.
 *  @author Cesare Stefanelli e Antonio Corradi
 *  @author modificato da G. C. e L.L.
 *  @version Monitor 1.1 
 */
public abstract class Monitor {

	Mutex mutex = new Mutex();
	Urgent urgentQueue = new Urgent(this);
	int urgentCount = 0;

	/**
	 * Costruttore della classe Monitor
	 */
	public Monitor() {
	}
	
	/**
	 * Da invocare come prima istruzione di una procedure entry;
	 * permette di acquisire il monitor
	 */
	protected void entraMonitor() {
		mutex.Wait();
	}
	
	/**
	 * Da invocare come ultima istruzione di una procedure entry;
	 * permette di rilasciare il monitor
	 */
	protected void esciMonitor() {
		if (urgentCount > 0) 
		{
		  // System.out.println(Thread.currentThread()+"esco dal monitor e signal su urgent");
		  urgentQueue.Signal();
		}
		else 
		{
		  // System.out.println(Thread.currentThread()+"esco dal monitor e signal su mutex");
		  mutex.Signal();
		}
	}
}

