package monitor;

/**
 *  Classe Urgent per sospensione dei processi che eseguono la Signal.
 *  @author Cesare Stefanelli e Antonio Corradi
 *  @author modificato da G. C. e L.L.
 *  @version Monitor 1.1 
 */
public class Urgent {
	private int n_sig = 0;	// tiene conto di notify per processi che non hanno ancora fatto la wait
	private Monitor mon;
	
         /**
	 * Costruttore della classe Urgent;
	 *
	 * @param mon il monitor in cui la variabile urgent
	 * &egrave; definita.
	 */
	public Urgent(Monitor mon)
	{
	  this.mon = mon;
	}
	
	/** Sospende sulla coda Urgent (a seguito di una signal sospensiva su una var condizione). */
	synchronized public void Wait() {
		if (n_sig == 0)
            	try{ 
			wait(); 
		} catch(InterruptedException e){}
		n_sig--;
		mon.urgentCount--;
	}

	/** Risveglia un processo sospeso sulla urgent. */
	synchronized public void Signal() {
		notify();
		n_sig++; 
	}

}

